/**********************************************************************************
temperatura_cliente_j2me.java
 
Midlet: Pregunta y envia el nombre de una ciudad (por metodo POST) al servidor web
el cual busca en una base de datos y regresa la temperatura de esa ciudad.
 
diciembre 2010 -  Rogelio Ferreira Escutia
*********************************************************************************/

import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class temperatura_cliente_j2me extends MIDlet implements CommandListener {

	private Display pantalla;
	private Form pantalla_preguntar, pantalla_imprimir;
	TextField ciudad;
	private Command boton_continuar, boton_salir;
	String url = "http://localhost:37995/temperatura_servidor_jsp/recibir.jsp";

	public temperatura_cliente_j2me() {
		pantalla = Display.getDisplay(this);
		pantalla_preguntar = new Form("Preguntar el nombre de la ciudad");
		ciudad = new TextField("Escribe el nombre de la ciudad:","",20,TextField.ANY);
		pantalla_preguntar.append(ciudad);
		boton_continuar = new Command ("Continuar",Command.OK,1);
		pantalla_preguntar.addCommand(boton_continuar);
		pantalla_preguntar.setCommandListener(this);

		pantalla_imprimir = new Form("Temperatura Actual");
		boton_salir = new Command("Salir",Command.EXIT,1);
		pantalla_imprimir.addCommand(boton_salir);
		pantalla_imprimir.setCommandListener(this);
	}

	public void startApp() {
		pantalla.setCurrent(pantalla_preguntar);
	}

	public void pauseApp() { }

	public void destroyApp(boolean unconditional) { }

	void llamarJSP( String url ) throws IOException {
		HttpConnection con = null;
		InputStream is = null;
		OutputStream os = null;
		StringBuffer sb = new StringBuffer();
		TextBox tb = null;

		try {
			con = (HttpConnection)Connector.open( url );
			con.setRequestMethod( HttpConnection.POST );
			con.setRequestProperty( "IF-Modified-Since", "05 Nov 2002 07:17:19 GMT" );
			con.setRequestProperty( "User-Agent", "Profile/MIDP-2.0 Configuration/CLDC-1.0");
			con.setRequestProperty( "Content-Language","es-ES" );
			con.setRequestProperty( "Content-Type", "application/x-www-form-urlencoded" );

			os = con.openOutputStream();
			os.write( ("ciudad="+ciudad.getString()).getBytes() );

			is = con.openDataInputStream();
			int ch;
			while( (ch=is.read()) != -1 ) {
				sb.append( (char)ch );
			}
			pantalla_imprimir.append(new StringItem(null, sb.toString()));
		} finally {
			if( is!= null ) is.close();
			if( os != null ) os.close();
			if( con != null ) con.close();
		}
	}

	public void commandAction(Command c, Displayable s) {
		if (c == boton_continuar) { 
			pantalla_imprimir.append(new StringItem(null, "La temperatura en "+ciudad.getString()+" es de:"));
			Thread hilo =  new Thread() {
			public void run() {
				try { llamarJSP(url); } catch (IOException e) { }
			}
			};
   	   hilo.start();
			pantalla.setCurrent(pantalla_imprimir);            
		}
		if (c == boton_salir) {
			destroyApp(false);
			notifyDestroyed();
		}
	}
} 
